import { useEffect, useRef, useState } from 'react';
import { MyRecorder } from './module/MyRecorder';
import { AliAsr } from './module/AliAsr';
export const RecordInfo = () => {
  const recorderRef = useRef<MyRecorder | null>(null);
  const asrRef = useRef<AliAsr | null>(null);
  const [mounted, setMounted] = useState(false);
  const [text, setText] = useState('');
  useEffect(() => {
    init();
  }, []);
  const init = async () => {
    recorderRef.current = new MyRecorder();
    asrRef.current = new AliAsr();
    asrRef.current?.init();
    const open = await recorderRef.current?.init();
    if (open) {
      setMounted(true);
    }
  };
  const start = () => {
    const startRecord = () => {
      recorderRef.current?.startRecord();
    };
    // asrRef.current?.start(startRecord, (msg) => {
    //   console.log('start fail', msg);
    // });
    startRecord();
  };
  const stop = async () => {
    const stopRecord = () => {
      recorderRef.current?.stopRecord();
    };

    const blob = await recorderRef.current?.stopRecord();
    if (blob !== false) {
      asrRef.current?.asr?.audioToText(
        blob,
        (text) => {
          console.log('text', text);
          setText(text);
        },
        (msg) => {
          console.log('text fail', msg);
        },
      );
    }
    console.log('stop');
    // asrRef.current?.stop(
    //   (text, abortMsg) => {
    //     console.log('stop', text, abortMsg);
    //     setText(text);
    //     stopRecord();
    //   },
    //   (msg) => {
    //     console.log('stop fail', msg);
    //     stopRecord();
    //   },
    // );
  };

  return (
    <div className='p-5'>
      <div className='flex py-4'>
        <button
          disabled={!mounted}
          onClick={start}
          className='btn btn-primary px-4 py-2 rounded-lg bg-blue-500 hover:bg-blue-600 active:bg-blue-700 transition-colors duration-200 text-white font-medium mr-4 cursor-pointer'>
          start
        </button>
        <button
          disabled={!mounted}
          onClick={stop}
          className='btn btn-danger px-4 py-2 rounded-lg bg-red-500 hover:bg-red-600 active:bg-red-700 transition-colors duration-200 text-white font-medium cursor-pointer'>
          stop
        </button>
      </div>
      <div className='mt-4'>{text}</div>
      <div className='recwave w-[100px] h-[100px] border p-2'></div>
    </div>
  );
};
